using Microsoft.Extensions.Logging.Abstractions;
using VegetableShop.API.Services;
using VegetableShop.Domain.Model;
using VegetableShop.Infrastructure.Persistence;
using Xunit;

namespace VegetableShop.API.IntegrationTests
{
    public class FarmerServicesTests
    {
        private readonly FarmerServices _farmerServices;
        private readonly FarmerRepositoryImpl _farmerRepository;

        public FarmerServicesTests()
        {
            var loggerFactory = new NullLoggerFactory();
            var context = new Context(loggerFactory);
            var vegetableRepository = new VegetableRepositoryImpl(context);
            _farmerRepository = new FarmerRepositoryImpl(context);
            _farmerServices = new FarmerServices(loggerFactory, _farmerRepository, vegetableRepository);
        }

        [Fact]
        public void ShouldPutVegetableOnSale()
        {
            var price = new Price(1, "EUR");
            _farmerServices.PutOnSale(1L, 1L, price);

            var vegetable = _farmerRepository.GetById(1L);
            Assert.NotNull(vegetable);
        }
    }
}