using Microsoft.Extensions.Logging;
using VegetableShop.Domain.Repositories;

namespace VegetableShop.API.Services
{
    public class ConsumerServices
    {
        private readonly ILogger<ConsumerServices> _logger;
        private readonly ConsumerRepository _consumerRepository;
        private readonly FarmerRepository _farmerRepository;
        private readonly VegetableRepository _vegetableRepository;

        public ConsumerServices(ILoggerFactory loggerFactory,
        ConsumerRepository consumerRepository, 
            FarmerRepository farmerRepository,
            VegetableRepository vegetableRepository)
        {
            _logger = loggerFactory.CreateLogger<ConsumerServices>();
            _consumerRepository = consumerRepository;
            _farmerRepository = farmerRepository;
            _vegetableRepository = vegetableRepository;
        }

        public void BuyVegetables(long consumerId, long farmerId, long vegetableId, uint quantity)
        {
            var consumer = _consumerRepository.GetById(consumerId);
            var farmer = _farmerRepository.GetById(farmerId);
            var vegetable = _vegetableRepository.GetById(vegetableId);
            _logger.LogDebug($"{consumer}, {farmer}, {vegetable}");
            consumer.Buy(quantity, vegetable, farmer);
        }
    }
}