using Microsoft.Extensions.Logging;
using VegetableShop.Domain.Model;
using VegetableShop.Domain.Repositories;

namespace VegetableShop.API.Services
{
    public class FarmerServices
    {
        private readonly ILogger<FarmerServices> _logger;
        private readonly FarmerRepository _farmerRepository;
        private readonly  VegetableRepository _vegetableRepository;

        public FarmerServices(ILoggerFactory loggerFactory, 
            FarmerRepository farmerRepository, 
            VegetableRepository vegetableRepository)
        {
            _logger = loggerFactory.CreateLogger<FarmerServices>();
            _farmerRepository = farmerRepository;
            _vegetableRepository = vegetableRepository;
        }

        public void PutOnSale(long farmerId, long vegetableId, Price price)
        {
            var farmer = _farmerRepository.GetById(farmerId);
            var vegetable = _vegetableRepository.GetById(vegetableId);
            _logger.LogDebug($"{farmer}, {vegetable}");
            farmer.PutOnSale(vegetable, price);
        }
    }
}