using FakeItEasy;
using Microsoft.Extensions.Logging;
using VegetableShop.Domain.Events;
using VegetableShop.Domain.Model;
using Xunit;

namespace VegetableShop.Domain.UnitTests
{
    public class LogItemOnFarmerPutOnSaleEventTest
    {
        private readonly LogItemOnFarmerPutOnSaleEvent _handler;
        private readonly ILogger<LogItemOnFarmerPutOnSaleEvent> _logger;

        public LogItemOnFarmerPutOnSaleEventTest()
        {
            _logger = A.Fake<ILogger<LogItemOnFarmerPutOnSaleEvent>>();
            _handler = new LogItemOnFarmerPutOnSaleEvent(_logger);
        }
        
        [Fact]
        public void Test1()
        {
            var evt = new FarmerPutOnSaleEvent(1L, A.Fake<Vegetable>(), new Price());
            _handler.Handle(evt);

            A.CallTo(() => _logger.LogInformation(default))
                .WithAnyArguments()
                .MustHaveHappenedOnceExactly();
        }
    }
}