using System.Collections;
using System.Collections.Generic;

namespace VegetableShop.Domain.Events
{
    public static class DomainEvents
    {
        private static readonly ICollection<EventHandler> Observers = new List<EventHandler>();
        public static void Notify(Event @event)
        {
            foreach (var obs in Observers)
            {
                obs.Handle(@event);
            }
        }

        public static void AddObserver(EventHandler obs) => Observers.Add(obs);

        public static bool RemoveObserver(EventHandler obs) => Observers.Remove(obs);
    }
}