using VegetableShop.Domain.Model;

namespace VegetableShop.Domain.Events
{
    public class FarmerPutOnSaleEvent : Event
    {
        public long Id { get; }
        public Vegetable Vegetable { get; }
        public Price Price { get; }

        public FarmerPutOnSaleEvent(in long id, Vegetable vegetable, Price price)
        {
            Id = id;
            Vegetable = vegetable;
            Price = price;
        }

        public override string ToString()
        {
            return $"{nameof(Id)}: {Id}, {nameof(Vegetable)}: {Vegetable}, {nameof(Price)}: {Price}";
        }
    }
}