using Microsoft.Extensions.Logging;

namespace VegetableShop.Domain.Events
{
    public class LogItemOnFarmerPutOnSaleEvent: EventHandler
    {
        private readonly ILogger<LogItemOnFarmerPutOnSaleEvent> _logger;

        public LogItemOnFarmerPutOnSaleEvent(ILoggerFactory loggerFactory)
        {
            _logger = loggerFactory.CreateLogger<LogItemOnFarmerPutOnSaleEvent>();
        }

        private void Handle(FarmerPutOnSaleEvent @event) 
            => _logger.LogInformation($"Received {nameof(@event)}, {@event}");

        public void Handle(Event @event) => Handle(@event as FarmerPutOnSaleEvent);
    }
}