using Microsoft.Extensions.Logging;

namespace VegetableShop.Domain.Model
{
    public class Consumer
    {
        private readonly ILogger<Consumer> _logger;

        public Consumer(ILoggerFactory loggerFactory)
        {
            _logger = loggerFactory.CreateLogger<Consumer>();
        }

        public void Buy(uint quantity, Vegetable vegetable, Farmer farmer)
        {
            _logger.LogInformation($"Buying {quantity} {vegetable} from {farmer}");
        }

        public void SubscribeToPriceDrop(Farmer farmer)
        {
            _logger.LogInformation($"Subscribing to price drop from {farmer}");
        }
    }
}