using System.Collections.Generic;
using Microsoft.Extensions.Logging;
using VegetableShop.Domain.Model;

namespace VegetableShop.Infrastructure.Persistence
{
    public class Context
    {
        public Dictionary<long, Consumer> Consumers { get; }
        public Dictionary<long, Farmer> Farmers { get; }
        public Dictionary<long, Vegetable> Vegetables { get; }

        public Context(ILoggerFactory loggerFactory)
        {
            Consumers = new Dictionary<long, Consumer> {
                { 1L, new Consumer(loggerFactory) }
            };
            Farmers = new Dictionary<long, Farmer> {
                { 1L, new Farmer(loggerFactory) }
            };
            Vegetables = new Dictionary<long, Vegetable> {
                { 1L, new Vegetable("carrot") }
            };;
        }
    }
}